package ru.mai.k806.sample;

public enum UnitsOfWeightMeasurement {

    @DisplayValue("Килограмм")
    KG(1.0),  //в одном кг: 1000гр 1кг 0.001т

    @DisplayValue("Грамм")
    GR(0.001), //грамм

    @DisplayValue("Миллиграмм")
    MILLGR(0.000001), //грамм

    @DisplayValue("label.uom.kg")
    TON(1000);  //тонна

    private final double koeff;

    UnitsOfWeightMeasurement(double koeff) {
        this.koeff = koeff;
    }

    public double ConvertFactorTo(UnitsOfWeightMeasurement to) {
        return this.koeff * (1.0 / to.koeff);
    }

    public java.lang.String toString() {
        try {
            DisplayValue displayValue = this.getClass().getField(this.name()).getAnnotation(DisplayValue.class);
            if (displayValue != null) {
                return displayValue.value();
            }
        } catch (NoSuchFieldException e) {
            e.printStackTrace();
        }
        return this.name();
    }
}
