package ru.mai.k806.sample;

import junit.framework.Assert;
import org.junit.Test;

import java.math.BigDecimal;
import java.sql.SQLException;

import static org.mockito.Mockito.*;

/**
 * Created by IntelliJ IDEA.
 * User: Eugene
 * Date: 29.10.2010
 * Time: 19:39:14
 * To change this template use File | Settings | File Templates.
 */
public class QuantityTest {

    @Test
    public void testConvert() throws Exception {
        Quantity q1 = new Quantity("50.000000", UnitsOfWeightMeasurement.GR);

        ConversionService conversionService = mock(ConversionService.class);
        when(conversionService.convert(any(UnitsOfWeightMeasurement.class), any(UnitsOfWeightMeasurement.class))).thenReturn(0.000001);

        q1.setConversionService(conversionService);
        Quantity converted = q1.Convert(UnitsOfWeightMeasurement.TON);

        Assert.assertNotNull(converted);
        Assert.assertEquals(new BigDecimal("0.000050").setScale(6), converted.m_value);
        verify(conversionService, times(2)).convert(UnitsOfWeightMeasurement.KG, UnitsOfWeightMeasurement.TON);
    }

    @Test
    public void testDoubleValue() {
        Quantity q1 = new Quantity("50.000000", UnitsOfWeightMeasurement.GR);
        q1.setConversionService(mock(ConversionService.class));
        Quantity testQuantity = q1.doubleValue(UnitsOfWeightMeasurement.KG);
        Assert.assertNotNull(testQuantity);
        Assert.assertEquals(new Quantity("0.100000", UnitsOfWeightMeasurement.KG), testQuantity);
    }

    @Test
    public void testAdd() throws Exception {
        
    }

    @Test
    public void testSubstruct() throws Exception {
    }

    @Test
    public void testMultiply() throws Exception {
    }

    @Test
    public void testDivide() throws Exception {
    }

    @Test
    public void testSplit() throws Exception {
    }
}
